
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CollectionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const collections = await db.collections.create(
            {
                id: data.id || undefined,
        
        collection_name: data.collection_name
        ||
        null
            ,
            
        handle: data.handle
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await collections.setStore( data.store || null, {
            transaction,
        });
        
        await collections.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.collections.getTableName(),
                belongsToColumn: 'image',
                belongsToId: collections.id,
            },
            data.image,
            options,
        );
        

        return collections;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const collectionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                collection_name: item.collection_name
            ||
            null
            ,
            
                handle: item.handle
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const collections = await db.collections.bulkCreate(collectionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < collections.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.collections.getTableName(),
                    belongsToColumn: 'image',
                    belongsToId: collections[i].id,
                },
                data[i].image,
                options,
            );
        }
        

        return collections;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const collections = await db.collections.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.collection_name !== undefined) updatePayload.collection_name = data.collection_name;
        
        
        if (data.handle !== undefined) updatePayload.handle = data.handle;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await collections.update(updatePayload, {transaction});

        
        
        if (data.store !== undefined) {
            await collections.setStore(
              
              data.store,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await collections.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.collections.getTableName(),
                belongsToColumn: 'image',
                belongsToId: collections.id,
            },
            data.image,
            options,
        );
        

        return collections;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const collections = await db.collections.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of collections) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of collections) {
                await record.destroy({transaction});
            }
        });


        return collections;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const collections = await db.collections.findByPk(id, options);

        await collections.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await collections.destroy({
            transaction
        });

        return collections;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const collections = await db.collections.findOne(
            { where },
            { transaction },
        );

        if (!collections) {
            return collections;
        }

        const output = collections.get({plain: true});

        
        
        
        
        
        
        
        
        output.products_collection = await collections.getProducts_collection({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.store = await collections.getStore({
            transaction
        });
        
        
        output.image = await collections.getImage({
            transaction
        });
        
        
        output.organizations = await collections.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.stores,
        as: 'store',
        
        where: filter.store ? {
          [Op.or]: [
            { id: { [Op.in]: filter.store.split('|').map(term => Utils.uuid(term)) } },
            {
              store_name: {
                [Op.or]: filter.store.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.collection_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'collections',
                        'collection_name',
                        filter.collection_name,
                    ),
                };
            }
            
            if (filter.handle) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'collections',
                        'handle',
                        filter.handle,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'collections',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.collections.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'collections',
                        'collection_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.collections.findAll({
            attributes: [ 'id', 'collection_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['collection_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.collection_name,
        }));
    }

    
};

